/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.wahlvorschlag.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class WahlvorschlagUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final java.lang.String discriminator;

    public java.lang.String getDiscriminator(){
      return discriminator;
    }

  protected final de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietUK gruppeImGebietUK;

    public de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietUK getGruppeImGebietUK(){
      return gruppeImGebietUK;
    }

  public WahlvorschlagUK(
java.lang.String discriminator
,   de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietUK gruppeImGebietUK
  ) {
    super();


      this.discriminator = discriminator;
        this.gruppeImGebietUK = gruppeImGebietUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((discriminator == null) ? 0 : discriminator.hashCode());
        
                    result = result + ((gruppeImGebietUK == null) ? 0 : gruppeImGebietUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            WahlvorschlagUK other = (WahlvorschlagUK) obj;

                if (discriminator == null) {
          if (other.discriminator != null) {
            return false;
          }
        } else if (!discriminator.equals(other.discriminator)) {
          return false;
        }
        
                if (gruppeImGebietUK == null) {
          if (other.gruppeImGebietUK != null) {
            return false;
          }
        } else if (!gruppeImGebietUK.equals(other.gruppeImGebietUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return WahlvorschlagConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gruppeImGebietUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(WahlvorschlagConstants.MESSAGE_KEY_ENTITY_EINZAHL, WahlvorschlagConstants.MESSAGE_KEY_DISCRIMINATOR_EINZAHL, discriminator));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "WahlvorschlagUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"discriminator="+discriminator
                                        +", "                +"gruppeImGebietUK="+gruppeImGebietUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(discriminator);
     return list;
   }

            public static <E extends Wahlvorschlag> java.util.Map<WahlvorschlagUK, E> mappeWahlvorschlagNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Wahlvorschlag::getWahlvorschlagUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Wahlvorschlag, WahlvorschlagUK> getWahlvorschlagToUKFunction() {
                return Wahlvorschlag::getWahlvorschlagUK;
                }

}
